#include "downloader.h"
#include <QSettings>
#include <widget.h>
#include "ui_widget.h"

Downloader::Downloader(QObject *parent) : QObject(parent)

{
    // Инициализируем менеджер ...
    manager = new QNetworkAccessManager();
    // ... и подключаем сигнал о завершении получения данных к обработчику полученного ответа

    connect(manager, &QNetworkAccessManager::finished, this, &Downloader::onResult);

    QSettings settings( "settings_update.conf", QSettings::IniFormat );//Чтение данных из файла настроек
    settings.beginGroup( "SettingsUpdate" );
    file_update = settings.value("file_update").toString();
    settings.endGroup();


}




void Downloader::getData()
{
    QUrl url(file_update + "update.zip"); // URL, к которому будем получать данные
    QNetworkRequest request;    // Отправляемый запрос
    request.setUrl(url);        // Устанавлвиваем URL в запрос
    manager->get(request);      // Выполняем запрос


}

void Downloader::onResult(QNetworkReply *reply)
{

             // Если в процесе получения данных произошла ошибка
    if(reply->error()){
        // Сообщаем об этом и показываем информацию об ошибках
         emit signalError(reply->errorString());
    } else {
        // В противном случае создаём объект для работы с файлом
        QFile *file = new QFile("update.zip");
        // Создаём файл или открываем его на перезапись ...
        if(file->open(QFile::WriteOnly)){
            file->write(reply->readAll());  // ... и записываем всю информацию со страницы в файл
            file->close();                  // закрываем файл
       // QFile("version_s.conf").remove();//удаление файла сравнения версий
        emit signal();//сигнал вывода информации об успешном скачивании файла
        emit onReady(); // Посылаем сигнал о завершении получения файла

        }
    }
}

