#include "widget.h"
#include "ui_widget.h"
#include <QSettings>
#include <QDir>
#include <QtGui/private/qzipwriter_p.h>
#include <QtGui/private/qzipreader_p.h>
#include <QSettings>
#include <QTimer>
#include <QProcess>


Widget::Widget(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::Widget)
{
    ui->setupUi(this);
    downloader = new Downloader(); // Инициализируем Downloader
    managerr = new QNetworkAccessManager();// по нажатию кнопки запускаем получение данных по http
    connect(ui->pushButton_6, &QPushButton::clicked, downloader, &Downloader::getData);// по окончанию получения данных считываем данные из файл
    connect(ui->pushButton_6, &QPushButton::clicked, this, &Widget::pushButtonDisable);
    connect(downloader, &Downloader::onReady, this, &Widget::unzip_update);
    connect(managerr, &QNetworkAccessManager::finished, this, &Widget::Result);
    connect(downloader,&Downloader::signal, this, &Widget::slot);

    connect(downloader, SIGNAL(signalError(QString)), this, SLOT(slotError(QString)));
    QSettings settings( "settings_update.conf", QSettings::IniFormat );//Чтение данных из фыйла настроек
    settings.beginGroup( "SettingsUpdate" );
    file_version_server = settings.value("file_version_server").toString();
    //QString file_update = settings.value("file_update").toString();

    directory_update = QApplication::applicationDirPath();//Копирует файлы в тотже каталок где установленны программа
    directory_update = directory_update + "\\";
    //qDebug() << directory_update;
   // directory_update = settings.value("directory_update").toString();
   // QString prog_update = settings.value("prog_update").toString();
    //QString s_file_update = settings.value("s_file_update").toString();
   // directory_log = settings.value("directory_log").toString();
    directory_log = QApplication::applicationDirPath();
    directory_log = directory_log + "\\";
   // qDebug() << directory_log;
    settings.endGroup();
    getDatas();


 }

Widget::~Widget()
{
    delete ui;
}



void Widget::getDatas()
{
    QUrl url(file_version_server + "version_s.conf"); // URL, к которому будем получать данные
    QNetworkRequest request;    // Отправляемый запрос
    request.setUrl(url);        // Устанавлвиваем URL в запрос
    managerr->get(request); // Выполняем запрос

}

void Widget::Result(QNetworkReply *reply)
{

    // Если в процесе получения данных произошла ошибка
    if(reply->error()){
        // Сообщаем об этом и показываем информацию об ошибках
        ui->textEdit->append("Ошибка получения файла проверки обновления." + reply->errorString());
       } else {
        // В противном случае создаём объект для работы с файлом
        QFile *file = new QFile("version_s.conf");
        // Создаём файл или открываем его на перезапись ...
        if(file->open(QFile::WriteOnly)){
            file->write(reply->readAll());  // ... и записываем всю информацию со страницы в файл
            file->close();                  // закрываем файл
            ui->textEdit->append("Файл проверки обновления получен.");
             updateversion();

            }
    }

}


void Widget::updateversion()
{
QSettings settings ("version.conf", QSettings::IniFormat );//Чтение данных из файла настроек
settings.beginGroup( "prog_version" );
QString version = settings.value("version").toString();
settings.endGroup();

QSettings settings_s("version_s.conf", QSettings::IniFormat );//Чтение данных из файла настроек
settings_s.beginGroup( "prog_version" );
QString version_s = settings_s.value("version").toString();
settings_s.endGroup();

if (version == version_s)
{
 ui->textEdit->append("Обновление не требуется.");
  QFile("version_s.conf").remove();
 ui->textEdit->append("Файл проверки версий удален.");
 ui->pushButton_6->setEnabled(false);
} else {
 ui->textEdit->append("Версия на сервере:" + version_s);
 ui->textEdit->append("Локальная версия:" + version);
 ui->textEdit->append("Необходимо обновить ПО.");
 ui->pushButton_6->setEnabled(true);
 }

}

void Widget::pushButtonDisable()
{
    ui->pushButton_6->setEnabled(false);
}

void Widget::slot()
{
   ui->textEdit->append("Файл обновления загружен.");

   //QTimer::singleShot(5000, this, SLOT(unzip_update()));
}

void Widget::slotError(QString error)
{
  ui->textEdit->append("Ошибка загрузки файла обновления.");
  ui->textEdit->append(error);
}

void Widget::unzip_update()
{

    QZipReader zip_reader(QLatin1String("update.zip"));
       if (zip_reader.exists()) {
           // вывод информации об архиве
          //qDebug() << "Number of items in the zip archive =" << zip_reader.count();
            int n = 1;
            int m;

         foreach (QZipReader::FileInfo info, zip_reader.fileInfoList()) {

              QFile file(directory_log + "log.txt");
               QString str = QDateTime::currentDateTime().toString("dd-MM-yyyy-h-m-s");
                if(info.isFile)
                   file.open(QIODevice::Append);
                   QTextStream out(&file);
                 out << str << " " <<info.filePath  << "\r\n";
                   file.close();
                    n=n+1;
                   m=n+1;
                   ui->progressBar->setMaximum(m);
                   ui->progressBar->setValue(n);
                  // else if (info.isDir)
                  // ui->textEdit->append(info.filePath);
                  // else
                  //  ui->textEdit->append(info.filePath);
           }  
         zip_reader.extractAll(directory_update);// распаковка архива по указанному пути


           QFile file("version_s.conf");
           QFile file1("version.conf");
           if(file1.exists())
           {
               //Файл уже существует. Перезаписать?
           }

           if(!file.open(QIODevice::ReadOnly))
           {

                ui->textEdit->append("Ошибка открытия для чтения.");
           }

           if(!file1.open(QIODevice::WriteOnly))
           {

                ui->textEdit->append("Ошибка открытия для записи.");
           }

           QByteArray a = file.readAll();
           file1.write(a);
           file.close();
           file1.close();

           QTimer::singleShot(5000, this, SLOT(DelFile()));
           ui->progressBar->setValue(n+1);
       }

       ui->textEdit->append("Файл проверки версий удален.");
       ui->textEdit->append("Файл обновления удален.");
       ui->textEdit->append("Обновление прошло успешно.");

}

void Widget::DelFile()
{
   QFile::rename ( "version_s.conf", "version.conf" );
   QFile("update.zip").remove();
   QFile("version_s.conf").remove();//удаление файла сравнения версий
}

void Widget::on_pushButton_3_clicked()//открытие формы настроек
{
    setting_update *show_setting_update = new setting_update(this);
    show_setting_update->setModal(true);
    show_setting_update->show();
    connect(show_setting_update, SIGNAL(finished(int)), this, SLOT(update_update()));
}


void Widget::update_update()
{
    ui->textEdit->clear();
    QSettings settings( "settings_update.conf", QSettings::IniFormat );//Чтение данных из фыйла настроек
    settings.beginGroup( "SettingsUpdate" );
    file_version_server = settings.value("file_version_server").toString();
    QString file_update = settings.value("file_update").toString();
    //directory_update = settings.value("directory_update").toString();
    directory_update = QApplication::applicationDirPath();
    QString prog_update = settings.value("prog_update").toString();
    QString s_file_update = settings.value("s_file_update").toString();
    directory_log = settings.value("directory_log").toString();
    settings.endGroup();
    getDatas();
 }


void Widget::on_pushButton_4_clicked()
{
    Help *help = new Help(this);
    help->setModal(true);
    help->show();
    //connect(show_setting_update, SIGNAL(finished(int)), this, SLOT(update_update()));
}


void Widget::on_pushButton_5_clicked() //окно с логами
{
    log = new LogDialog(this);
    log->setModal(true);
    log->show();
}

